Issue1747

classification
Title: Jython shutdown closer java.util.ConcurrentModificationException
Type: crash Severity: normal
Components: Core Versions: Jython 2.7
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: zyasoft Nosy List: amak, fwierzbicki, mksenzov, zyasoft
Priority: Keywords:

Created on 2011-05-11.18:25:23 by mksenzov, last changed 2014-07-09.23:59:54 by zyasoft.

Messages
msg6525 (view) Author: Mikhail Ksenzov (mksenzov) Date: 2011-05-11.18:26:21
I am using jython 2.5.2 (could not find it in the list of versions, so I picked the closest one from the list). After executing my scriipt jython crushed with an exception:

Exception in thread "Jython Shutdown Closer" java.util.ConcurrentModificationException
	at java.util.LinkedHashMap$LinkedHashIterator.nextEntry(Unknown Source)
	at java.util.LinkedHashMap$KeyIterator.next(Unknown Source)
	at org.python.core.PySystemState$PySystemStateCloser$ShutdownCloser.run(PySystemState.java:1385)
msg7710 (view) Author: Frank Wierzbicki (fwierzbicki) Date: 2013-02-19.23:52:08
Sorry about the versions - fixing now to a generic "Jython 2.5". Do you have a code sample that would allow us to reproduce this?
msg8502 (view) Author: Jim Baker (zyasoft) Date: 2014-05-21.23:33:38
There's a potentially related pull request in https://bitbucket.org/jython/jython/pull-request/19/pysystemstateclosershutdowncloser-use/diff
msg8838 (view) Author: Jim Baker (zyasoft) Date: 2014-06-28.04:15:17
resourceClosers should be changed to a ConcurrentSkipListSet
msg8840 (view) Author: Jim Baker (zyasoft) Date: 2014-06-28.05:09:08
Oops, ConcurrentSkipListSet does not support update ordering, although that would be super handy (but hard to actually implement). Presumably best to just make runClosers synchronized.
msg8841 (view) Author: Jim Baker (zyasoft) Date: 2014-06-28.06:25:20
Fixed as of http://hg.python.org/jython/rev/b2c87cfba346
History
Date User Action Args
2014-07-09 23:59:54zyasoftsetstatus: pending -> closed
2014-06-28 06:25:20zyasoftsetstatus: open -> pending
resolution: accepted -> fixed
messages: + msg8841
2014-06-28 05:09:08zyasoftsetmessages: + msg8840
2014-06-28 04:15:23zyasoftsetversions: + Jython 2.7, - Jython 2.5
2014-06-28 04:15:17zyasoftsetassignee: zyasoft
resolution: accepted
messages: + msg8838
2014-05-21 23:33:38zyasoftsetmessages: + msg8502
2014-05-21 23:07:49zyasoftsetnosy: + zyasoft
2013-02-26 07:58:55amaksetnosy: + amak
2013-02-19 23:52:08fwierzbickisetnosy: + fwierzbicki
messages: + msg7710
versions: + Jython 2.5, - 2.5.2rc
2011-05-11 18:26:21mksenzovsetmessages: + msg6525
2011-05-11 18:25:23mksenzovcreate